Loading...
Searching...
No Matches
Sip_subscription_state

## Data Structures

struct | sip_subscription_state_s
| Structure for Subscription-State header. More...

## Macros

#define | sip_subscription_state(sip)
| Access a SIP Subscription-State header structure sip_subscription_state_t from sip_t.
#define | SIP_SUBSCRIPTION_STATE_INIT()
| Initializer for structure sip_subscription_state_t.
#define | SIPTAG_SUBSCRIPTION_STATE(x)
| Tag list item for pointer to a Subscription-State header structure sip_subscription_state_t.
#define | SIPTAG_SUBSCRIPTION_STATE_REF(x)
| Tag list item for reference to a Subscription-State header pointer.
#define | SIPTAG_SUBSCRIPTION_STATE_STR(s)
| Tag list item for string with Subscription-State header value.
#define | SIPTAG_SUBSCRIPTION_STATE_STR_REF(x)
| Tag list item for reference to a Subscription-State header string.

## Typedefs

typedef struct sip_subscription_state_s | sip_subscription_state_t
| @

## Functions

issize_t | sip_subscription_state_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Subscription-State header.
issize_t | sip_subscription_state_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Subscription-State header.
sip_subscription_state_t * | sip_subscription_state_init (sip_subscription_state_t x[1])
| Initialize a structure sip_subscription_state_t.
int | sip_is_subscription_state (sip_header_t const *header)
| Test if header object is instance of sip_subscription_state_t.
sip_subscription_state_t * | sip_subscription_state_dup (su_home_t *home, sip_subscription_state_t const *hdr))
| Duplicate a list of Subscription-State header header structures sip_subscription_state_t.
sip_subscription_state_t * | sip_subscription_state_copy (su_home_t *home, sip_subscription_state_t const *hdr))
| Copy a list of Subscription-State header header structures sip_subscription_state_t.
sip_subscription_state_t * | sip_subscription_state_make (su_home_t *home, char const *s))
| Make a Subscription-State header structure sip_subscription_state_t.
sip_subscription_state_t * | sip_subscription_state_format (su_home_t *home, char const *fmt,...)))
| Make a Subscription-State header from formatting result.

## Variables

msg_hclass_t | sip_subscription_state_class []
| Header class for Subscription-State header.
tag_typedef_t | siptag_subscription_state
| Tag for Subscription-State header object.
tag_typedef_t | siptag_subscription_state_str
| Tag for string with Subscription-State header value.

## Detailed Description

## Macro Definition Documentation

## SIP_SUBSCRIPTION_STATE_INIT

#define SIP_SUBSCRIPTION_STATE_INIT | ( |  | ) |

Initializer for structure sip_subscription_state_t.

A static sip_subscription_state_t structure for Subscription-State header must be initialized with the SIP_SUBSCRIPTION_STATE_INIT() macro. For instance,

sip_subscription_state_t sip_subscription_state = SIP_SUBSCRIPTION_STATE_INIT;
sip_subscription_state
#define sip_subscription_state(sip)
Access a SIP Subscription-State header structure sip_subscription_state_t from sip_t.
Definition sip_protos.h:9175
sip_subscription_state_t
struct sip_subscription_state_s sip_subscription_state_t
@
Definition sip.h:193
SIP_SUBSCRIPTION_STATE_INIT
#define SIP_SUBSCRIPTION_STATE_INIT()
Initializer for structure sip_subscription_state_t.
Definition sip_protos.h:9192

## SIPTAG_SUBSCRIPTION_STATE

#define SIPTAG_SUBSCRIPTION_STATE | ( |  | x | ) |

Tag list item for pointer to a Subscription-State header structure sip_subscription_state_t.

The SIPTAG_SUBSCRIPTION_STATE() macro is used to include a tag item with a pointer to a sip_subscription_state_t structure in a tag list.

Parameters

  x | pointer to a sip_subscription_state_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_SUBSCRIPTION_STATE_REF().

## SIPTAG_SUBSCRIPTION_STATE_STR

#define SIPTAG_SUBSCRIPTION_STATE_STR | ( |  | s | ) |

Tag list item for string with Subscription-State header value.

The SIPTAG_SUBSCRIPTION_STATE_STR() macro is used to include a tag item with a string containing value of a sip_subscription_state_t header in a tag list.

Parameters

  s | pointer to a string containing Subscription-State header value, or NULL.

The string in SIPTAG_SUBSCRIPTION_STATE_STR() can be converted to a sip_subscription_state_t header structure by giving the string s has second argument to function sip_subscription_state_make().

The corresponding tag taking reference parameter is SIPTAG_SUBSCRIPTION_STATE_STR_REF().

## Typedef Documentation

## sip_subscription_state_t

typedef struct sip_subscription_state_s sip_subscription_state_t

@

The Subscription-State header is used to indicate in which state a subscription is. Its syntax is defined in RFC 3265 section 4.2.4 as follows:

Subscription-State = "Subscription-State" HCOLON substate-value
*( SEMI subexp-params )
substate-value = "active" / "pending" / "terminated"
/ extension-substate
extension-substate = token
subexp-params = ("reason" EQUAL event-reason-value)
/ ("expires" EQUAL delta-seconds)
/ ("retry-after" EQUAL delta-seconds)
/ generic-param
event-reason-value = "deactivated"
/ "probation"
/ "rejected"
/ "timeout"
/ "giveup"
/ "noresource"
/ event-reason-extension
event-reason-extension = token

The parsed Subscription-State header is stored in sip_subscription_state_t structure.

The structure sip_subscription_state_t contains representation of an Subscription-State header.

The sip_subscription_state_t is defined as follows:

typedef struct sip_subscription_state_s
{
sip_common_t ss_common[1];
sip_unknown_t *ss_next;
// Subscription state: "pending", "active" or "terminated"
char const *ss_substate;
msg_param_t const *ss_params; // List of parameters
char const *ss_reason; // Reason of terminating
char const *ss_expires; // Subscription lifetime in seconds
char const *ss_retry_after; // Value of retry-after parameter
} sip_subscription_state_t;
sip_unknown_t
msg_unknown_t sip_unknown_t
@
Definition sip.h:135
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_subscription_state_s
Structure for Subscription-State header.
Definition sip.h:727
sip_subscription_state_s::ss_reason
char const * ss_reason
Reason for termination.
Definition sip.h:733
sip_subscription_state_s::ss_substate
char const * ss_substate
Subscription state: "pending", "active" or "terminated".
Definition sip.h:731
sip_subscription_state_s::ss_params
msg_param_t const * ss_params
List of parameters.
Definition sip.h:732
sip_subscription_state_s::ss_common
sip_common_t ss_common[1]
Common fragment info.
Definition sip.h:728
sip_subscription_state_s::ss_retry_after
char const * ss_retry_after
Value of retry-after parameter.
Definition sip.h:735
sip_subscription_state_s::ss_next
sip_error_t * ss_next
Dummy link to next.
Definition sip.h:729
sip_subscription_state_s::ss_expires
char const * ss_expires
Subscription lifetime.
Definition sip.h:734

## Function Documentation

## sip_is_subscription_state()

int sip_is_subscription_state | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_subscription_state_t.

Check if the header class is an instance of Subscription-State header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header subscription_state
  0 | (false) otherwise

## sip_subscription_state_copy()

sip_subscription_state_t * sip_subscription_state_copy | ( | su_home_t * | home,
|  | sip_subscription_state_t const * | hdr )

inline

Copy a list of Subscription-State header header structures sip_subscription_state_t.

The function sip_subscription_state_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  subscription_state = sip_subscription_state_copy(home, sip->sip_subscription_state);
  sip_subscription_state_copy
  sip_subscription_state_t * sip_subscription_state_copy(su_home_t *home, sip_subscription_state_t const *hdr))
  Copy a list of Subscription-State header header structures sip_subscription_state_t.
  Definition sip_protos.h:9322

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_subscription_state_dup()

sip_subscription_state_t * sip_subscription_state_dup | ( | su_home_t * | home,
|  | sip_subscription_state_t const * | hdr )

inline

Duplicate a list of Subscription-State header header structures sip_subscription_state_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  subscription_state = sip_subscription_state_dup(home, sip->sip_subscription_state);
  sip_subscription_state_dup
  sip_subscription_state_t * sip_subscription_state_dup(su_home_t *home, sip_subscription_state_t const *hdr))
  Duplicate a list of Subscription-State header header structures sip_subscription_state_t.
  Definition sip_protos.h:9279

Returns
  A pointer to the newly duplicated sip_subscription_state_t header structure, or NULL upon an error.

## sip_subscription_state_format()

sip_subscription_state_t * sip_subscription_state_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Subscription-State header from formatting result.

Make a new sip_subscription_state_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_subscription_state_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_subscription_state_init()

sip_subscription_state_t * sip_subscription_state_init | ( | sip_subscription_state_t | x[1] | ) |

inline

Initialize a structure sip_subscription_state_t.

An sip_subscription_state_t structure for Subscription-State header can be initialized with the sip_subscription_state_init() function/macro. For instance,

sip_subscription_state_t sip_subscription_state;
sip_subscription_state_init(&sip_subscription_state);
sip_subscription_state_init
sip_subscription_state_t * sip_subscription_state_init(sip_subscription_state_t x[1])
Initialize a structure sip_subscription_state_t.
Definition sip_protos.h:9210

## sip_subscription_state_make()

sip_subscription_state_t * sip_subscription_state_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Subscription-State header structure sip_subscription_state_t.

The function sip_subscription_state_make() makes a new sip_subscription_state_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_subscription_state_t header structure, or NULL upon an error.

## Variable Documentation

## sip_subscription_state_class

msg_hclass_t sip_subscription_state_class[]

extern

Header class for Subscription-State header.

The header class sip_subscription_state_class defines how a SIP Subscription-State header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_subscription_state_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.